library ieee;
use ieee.std_logic_1164.all;

entity adder32 is
    port(x,y:in std_logic_vector(31 downto 0);
        c0:in std_logic; c32:out std_logic;
        sum:out std_logic_vector(31 downto 0));
    end adder32;
    
    architecture adder32_arch of adder32 is
    
    component full_adder32
        port (
        X: in STD_LOGIC;
        Y: in STD_LOGIC;
        CIN: in STD_LOGIC;
        sum: out STD_LOGIC;
        COUT: out STD_LOGIC);
    end component;
    
    signal c:std_logic_vector(0 to 32);
    begin   
    
    g: for b in 0 to 31 generate
        u: full_adder32 port map(x=>x(b),y=>y(b),cin=>c(b),sum=>sum(b),cout=>c(b+1));
    end generate;
    
    c(0)<=c0;
    c32<=c(32);
    
end adder32_arch;