library ieee;
use ieee.std_logic_1164.all;

entity adder is
    port(x,y:in std_logic_vector(7 downto 0);
        c0:in std_logic; c8:out std_logic;
        s:out std_logic_vector(7 downto 0));
    end adder;
    
    architecture adder_arch of adder is
    
    component full_adder
        port (
        X: in STD_LOGIC;
        Y: in STD_LOGIC;
        CIN: in STD_LOGIC;
        S: out STD_LOGIC;
        COUT: out STD_LOGIC
        );
    end component;
    
    signal c:std_logic_vector(0 to 8);
    begin   
    
    g: for b in 0 to 7 generate
        u: full_adder port map(x=>x(b),y=>y(b),cin=>c(b),s=>s(b),cout=>c(b+1));
    end generate;
    
    c(0)<=c0;
    c8<=c(8);
    
end adder_arch;
        
        