library ieee;
use ieee.std_logic_1164.all;

entity Rregister is
    port(LR,ER,CLK,w: in std_logic;
        R:in std_logic_vector(7 downto 0);
        Q:out std_logic);
    end Rregister;
    
    architecture Rregister_arch of Rregister is
        signal IQ:std_logic_vector(7 downto 0):= (others => '0');
        begin
            process(CLK)                
                begin
                    if CLK'event and CLK='1' then
                        if LR='1' then IQ<=R;
                        elsif ER='1' then IQ<=IQ(6 downto 0) & w;
                        elsif LR='0' and ER='0' then IQ<=IQ;
                    end if;                
                end if;
                Q<=IQ(7);                
                
            end process;
        end Rregister_arch;