library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_unsigned.all;

entity counter is
    port (
        CLK: in STD_LOGIC;
        LC: in STD_LOGIC;
        EC: in STD_LOGIC;        
        D: in STD_LOGIC_VECTOR (3 downto 0);
        Q: out STD_LOGIC_VECTOR (3 downto 0);
        count: out STD_LOGIC
    );
end counter;

architecture counter_arch of counter is
signal IQ: std_logic_vector(3 downto 0):= (others => '1');
begin
   process (CLK,IQ)
   begin
       if (CLK'event and CLK = '1') then
          if LC = '1' then IQ <= (others => '1');
          elsif EC = '1' then IQ <= IQ-1;         
          end if;
       end if;
       
       if (IQ = 8) then count <= '1';
       else count <= '0';
       end if;
       Q <= IQ-8;
    end process;
end counter_arch;
