library ieee;
use ieee.std_logic_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_unsigned.all;

entity state_machine32 is
    port(s: in std_logic;
        z: in std_logic;
        cout: in std_logic;
        CLK: in std_logic;
        Rsel: out std_logic;
        LR: out std_logic;
        LC: out std_logic;
        ER: out std_logic;
        EA: out std_logic;
        EQ: out std_logic;
        EC: out std_logic);
    end state_machine32;
    
    architecture state_machine32_arch of state_machine32 is
         
         type state_type is (s1,s2,s3,s4);
         signal sreg,snext: state_type;
         
         begin
                
            process(CLK)
                begin
                    if CLK'event and CLK='1' then
                        sreg<=snext;
                    end if;
                end process;
                
            process(sreg,s,z,cout)
            begin
                
                if s='0' then Rsel<='0';LR<='0';LC<='0';ER<='0';
                EA<='0';EQ<='0';EC<='0';
                end if;
                
                case sreg is
                when s1=> 
                   
                   if s='1' then snext<=s2;Rsel<='0';LR<='1';LC<='1';ER<='0'; 
                   EA<='0';EQ<='0'; EC<='0';
                   else snext<=s1;
                   end if;
                when s2=>
                   EA<='1';ER<='1';EC<='1';EQ<='0';LC<='0';LR<='0';
                   Rsel<='1';
                   snext<=s3;
                when s3=>
                   EQ<='1';Rsel<='1';EC<='1';ER<='0';EA<='0';LC<='0';
                   if cout='0' then LR<='0';
                   else LR<='1';
                   end if;
                   if z='0' then snext<=s2;
                   elsif z='1' then snext<=s4;
                   end if;
                when s4=>
                   if s='0' then snext<=s1;
                   elsif s='1' then snext<=s4;
                   end if;
                   Rsel<='1';LR<='0';LC<='0';ER<='0';EA<='0';EQ<='0';
                   EC<='0';
                when others => snext<=s1;
                    
                if s='0' then Rsel<='0';LR<='0';LC<='0';ER<='0';
                EA<='0';EQ<='0';EC<='0';
            end if;
                
                if z='1' then Rsel<='0';LR<='0';LC<='0';ER<='0';
                EA<='0';EQ<='0';EC<='0'; snext<=s1;               
            end if;  
            end case;                     
                       
            end process;
            
  --          with sreg select
  --          z<='1' when s0,
   --            '0' when others;
        
end state_machine32_arch;